// Code generated by gotdgen, DO NOT EDIT.

package tdapi

import (
	"context"
	"errors"
	"fmt"
	"sort"
	"strings"

	"go.uber.org/multierr"

	"github.com/gotd/td/bin"
	"github.com/gotd/td/tdjson"
	"github.com/gotd/td/tdp"
	"github.com/gotd/td/tgerr"
)

// No-op definition for keeping imports.
var (
	_ = bin.Buffer{}
	_ = context.Background()
	_ = fmt.Stringer(nil)
	_ = strings.Builder{}
	_ = errors.Is
	_ = multierr.AppendInto
	_ = sort.Ints
	_ = tdp.Format
	_ = tgerr.Error{}
	_ = tdjson.Encoder{}
)

// Audio represents TL type `audio#b9b4c7de`.
type Audio struct {
	// Duration of the audio, in seconds; as defined by the sender
	Duration int32
	// Title of the audio; as defined by the sender
	Title string
	// Performer of the audio; as defined by the sender
	Performer string
	// Original name of the file; as defined by the sender
	FileName string
	// The MIME type of the file; as defined by the sender
	MimeType string
	// The minithumbnail of the album cover; may be null
	AlbumCoverMinithumbnail Minithumbnail
	// The thumbnail of the album cover in JPEG format; as defined by the sender. The full
	// size thumbnail is supposed to be extracted from the downloaded file; may be null
	AlbumCoverThumbnail Thumbnail
	// File containing the audio
	Audio File
}

// AudioTypeID is TL type id of Audio.
const AudioTypeID = 0xb9b4c7de

// Ensuring interfaces in compile-time for Audio.
var (
	_ bin.Encoder     = &Audio{}
	_ bin.Decoder     = &Audio{}
	_ bin.BareEncoder = &Audio{}
	_ bin.BareDecoder = &Audio{}
)

func (a *Audio) Zero() bool {
	if a == nil {
		return true
	}
	if !(a.Duration == 0) {
		return false
	}
	if !(a.Title == "") {
		return false
	}
	if !(a.Performer == "") {
		return false
	}
	if !(a.FileName == "") {
		return false
	}
	if !(a.MimeType == "") {
		return false
	}
	if !(a.AlbumCoverMinithumbnail.Zero()) {
		return false
	}
	if !(a.AlbumCoverThumbnail.Zero()) {
		return false
	}
	if !(a.Audio.Zero()) {
		return false
	}

	return true
}

// String implements fmt.Stringer.
func (a *Audio) String() string {
	if a == nil {
		return "Audio(nil)"
	}
	type Alias Audio
	return fmt.Sprintf("Audio%+v", Alias(*a))
}

// TypeID returns type id in TL schema.
//
// See https://core.telegram.org/mtproto/TL-tl#remarks.
func (*Audio) TypeID() uint32 {
	return AudioTypeID
}

// TypeName returns name of type in TL schema.
func (*Audio) TypeName() string {
	return "audio"
}

// TypeInfo returns info about TL type.
func (a *Audio) TypeInfo() tdp.Type {
	typ := tdp.Type{
		Name: "audio",
		ID:   AudioTypeID,
	}
	if a == nil {
		typ.Null = true
		return typ
	}
	typ.Fields = []tdp.Field{
		{
			Name:       "Duration",
			SchemaName: "duration",
		},
		{
			Name:       "Title",
			SchemaName: "title",
		},
		{
			Name:       "Performer",
			SchemaName: "performer",
		},
		{
			Name:       "FileName",
			SchemaName: "file_name",
		},
		{
			Name:       "MimeType",
			SchemaName: "mime_type",
		},
		{
			Name:       "AlbumCoverMinithumbnail",
			SchemaName: "album_cover_minithumbnail",
		},
		{
			Name:       "AlbumCoverThumbnail",
			SchemaName: "album_cover_thumbnail",
		},
		{
			Name:       "Audio",
			SchemaName: "audio",
		},
	}
	return typ
}

// Encode implements bin.Encoder.
func (a *Audio) Encode(b *bin.Buffer) error {
	if a == nil {
		return fmt.Errorf("can't encode audio#b9b4c7de as nil")
	}
	b.PutID(AudioTypeID)
	return a.EncodeBare(b)
}

// EncodeBare implements bin.BareEncoder.
func (a *Audio) EncodeBare(b *bin.Buffer) error {
	if a == nil {
		return fmt.Errorf("can't encode audio#b9b4c7de as nil")
	}
	b.PutInt32(a.Duration)
	b.PutString(a.Title)
	b.PutString(a.Performer)
	b.PutString(a.FileName)
	b.PutString(a.MimeType)
	if err := a.AlbumCoverMinithumbnail.Encode(b); err != nil {
		return fmt.Errorf("unable to encode audio#b9b4c7de: field album_cover_minithumbnail: %w", err)
	}
	if err := a.AlbumCoverThumbnail.Encode(b); err != nil {
		return fmt.Errorf("unable to encode audio#b9b4c7de: field album_cover_thumbnail: %w", err)
	}
	if err := a.Audio.Encode(b); err != nil {
		return fmt.Errorf("unable to encode audio#b9b4c7de: field audio: %w", err)
	}
	return nil
}

// Decode implements bin.Decoder.
func (a *Audio) Decode(b *bin.Buffer) error {
	if a == nil {
		return fmt.Errorf("can't decode audio#b9b4c7de to nil")
	}
	if err := b.ConsumeID(AudioTypeID); err != nil {
		return fmt.Errorf("unable to decode audio#b9b4c7de: %w", err)
	}
	return a.DecodeBare(b)
}

// DecodeBare implements bin.BareDecoder.
func (a *Audio) DecodeBare(b *bin.Buffer) error {
	if a == nil {
		return fmt.Errorf("can't decode audio#b9b4c7de to nil")
	}
	{
		value, err := b.Int32()
		if err != nil {
			return fmt.Errorf("unable to decode audio#b9b4c7de: field duration: %w", err)
		}
		a.Duration = value
	}
	{
		value, err := b.String()
		if err != nil {
			return fmt.Errorf("unable to decode audio#b9b4c7de: field title: %w", err)
		}
		a.Title = value
	}
	{
		value, err := b.String()
		if err != nil {
			return fmt.Errorf("unable to decode audio#b9b4c7de: field performer: %w", err)
		}
		a.Performer = value
	}
	{
		value, err := b.String()
		if err != nil {
			return fmt.Errorf("unable to decode audio#b9b4c7de: field file_name: %w", err)
		}
		a.FileName = value
	}
	{
		value, err := b.String()
		if err != nil {
			return fmt.Errorf("unable to decode audio#b9b4c7de: field mime_type: %w", err)
		}
		a.MimeType = value
	}
	{
		if err := a.AlbumCoverMinithumbnail.Decode(b); err != nil {
			return fmt.Errorf("unable to decode audio#b9b4c7de: field album_cover_minithumbnail: %w", err)
		}
	}
	{
		if err := a.AlbumCoverThumbnail.Decode(b); err != nil {
			return fmt.Errorf("unable to decode audio#b9b4c7de: field album_cover_thumbnail: %w", err)
		}
	}
	{
		if err := a.Audio.Decode(b); err != nil {
			return fmt.Errorf("unable to decode audio#b9b4c7de: field audio: %w", err)
		}
	}
	return nil
}

// EncodeTDLibJSON implements tdjson.TDLibEncoder.
func (a *Audio) EncodeTDLibJSON(b tdjson.Encoder) error {
	if a == nil {
		return fmt.Errorf("can't encode audio#b9b4c7de as nil")
	}
	b.ObjStart()
	b.PutID("audio")
	b.Comma()
	b.FieldStart("duration")
	b.PutInt32(a.Duration)
	b.Comma()
	b.FieldStart("title")
	b.PutString(a.Title)
	b.Comma()
	b.FieldStart("performer")
	b.PutString(a.Performer)
	b.Comma()
	b.FieldStart("file_name")
	b.PutString(a.FileName)
	b.Comma()
	b.FieldStart("mime_type")
	b.PutString(a.MimeType)
	b.Comma()
	b.FieldStart("album_cover_minithumbnail")
	if err := a.AlbumCoverMinithumbnail.EncodeTDLibJSON(b); err != nil {
		return fmt.Errorf("unable to encode audio#b9b4c7de: field album_cover_minithumbnail: %w", err)
	}
	b.Comma()
	b.FieldStart("album_cover_thumbnail")
	if err := a.AlbumCoverThumbnail.EncodeTDLibJSON(b); err != nil {
		return fmt.Errorf("unable to encode audio#b9b4c7de: field album_cover_thumbnail: %w", err)
	}
	b.Comma()
	b.FieldStart("audio")
	if err := a.Audio.EncodeTDLibJSON(b); err != nil {
		return fmt.Errorf("unable to encode audio#b9b4c7de: field audio: %w", err)
	}
	b.Comma()
	b.StripComma()
	b.ObjEnd()
	return nil
}

// DecodeTDLibJSON implements tdjson.TDLibDecoder.
func (a *Audio) DecodeTDLibJSON(b tdjson.Decoder) error {
	if a == nil {
		return fmt.Errorf("can't decode audio#b9b4c7de to nil")
	}

	return b.Obj(func(b tdjson.Decoder, key []byte) error {
		switch string(key) {
		case tdjson.TypeField:
			if err := b.ConsumeID("audio"); err != nil {
				return fmt.Errorf("unable to decode audio#b9b4c7de: %w", err)
			}
		case "duration":
			value, err := b.Int32()
			if err != nil {
				return fmt.Errorf("unable to decode audio#b9b4c7de: field duration: %w", err)
			}
			a.Duration = value
		case "title":
			value, err := b.String()
			if err != nil {
				return fmt.Errorf("unable to decode audio#b9b4c7de: field title: %w", err)
			}
			a.Title = value
		case "performer":
			value, err := b.String()
			if err != nil {
				return fmt.Errorf("unable to decode audio#b9b4c7de: field performer: %w", err)
			}
			a.Performer = value
		case "file_name":
			value, err := b.String()
			if err != nil {
				return fmt.Errorf("unable to decode audio#b9b4c7de: field file_name: %w", err)
			}
			a.FileName = value
		case "mime_type":
			value, err := b.String()
			if err != nil {
				return fmt.Errorf("unable to decode audio#b9b4c7de: field mime_type: %w", err)
			}
			a.MimeType = value
		case "album_cover_minithumbnail":
			if err := a.AlbumCoverMinithumbnail.DecodeTDLibJSON(b); err != nil {
				return fmt.Errorf("unable to decode audio#b9b4c7de: field album_cover_minithumbnail: %w", err)
			}
		case "album_cover_thumbnail":
			if err := a.AlbumCoverThumbnail.DecodeTDLibJSON(b); err != nil {
				return fmt.Errorf("unable to decode audio#b9b4c7de: field album_cover_thumbnail: %w", err)
			}
		case "audio":
			if err := a.Audio.DecodeTDLibJSON(b); err != nil {
				return fmt.Errorf("unable to decode audio#b9b4c7de: field audio: %w", err)
			}
		default:
			return b.Skip()
		}
		return nil
	})
}

// GetDuration returns value of Duration field.
func (a *Audio) GetDuration() (value int32) {
	if a == nil {
		return
	}
	return a.Duration
}

// GetTitle returns value of Title field.
func (a *Audio) GetTitle() (value string) {
	if a == nil {
		return
	}
	return a.Title
}

// GetPerformer returns value of Performer field.
func (a *Audio) GetPerformer() (value string) {
	if a == nil {
		return
	}
	return a.Performer
}

// GetFileName returns value of FileName field.
func (a *Audio) GetFileName() (value string) {
	if a == nil {
		return
	}
	return a.FileName
}

// GetMimeType returns value of MimeType field.
func (a *Audio) GetMimeType() (value string) {
	if a == nil {
		return
	}
	return a.MimeType
}

// GetAlbumCoverMinithumbnail returns value of AlbumCoverMinithumbnail field.
func (a *Audio) GetAlbumCoverMinithumbnail() (value Minithumbnail) {
	if a == nil {
		return
	}
	return a.AlbumCoverMinithumbnail
}

// GetAlbumCoverThumbnail returns value of AlbumCoverThumbnail field.
func (a *Audio) GetAlbumCoverThumbnail() (value Thumbnail) {
	if a == nil {
		return
	}
	return a.AlbumCoverThumbnail
}

// GetAudio returns value of Audio field.
func (a *Audio) GetAudio() (value File) {
	if a == nil {
		return
	}
	return a.Audio
}
