// Code generated by gotdgen, DO NOT EDIT.

package tdapi

import (
	"context"
	"errors"
	"fmt"
	"sort"
	"strings"

	"go.uber.org/multierr"

	"github.com/gotd/td/bin"
	"github.com/gotd/td/tdjson"
	"github.com/gotd/td/tdp"
	"github.com/gotd/td/tgerr"
)

// No-op definition for keeping imports.
var (
	_ = bin.Buffer{}
	_ = context.Background()
	_ = fmt.Stringer(nil)
	_ = strings.Builder{}
	_ = errors.Is
	_ = multierr.AppendInto
	_ = sort.Ints
	_ = tdp.Format
	_ = tgerr.Error{}
	_ = tdjson.Encoder{}
)

// ReorderChatFiltersRequest represents TL type `reorderChatFilters#c3a5313d`.
type ReorderChatFiltersRequest struct {
	// Identifiers of chat filters in the new correct order
	ChatFilterIDs []int32
}

// ReorderChatFiltersRequestTypeID is TL type id of ReorderChatFiltersRequest.
const ReorderChatFiltersRequestTypeID = 0xc3a5313d

// Ensuring interfaces in compile-time for ReorderChatFiltersRequest.
var (
	_ bin.Encoder     = &ReorderChatFiltersRequest{}
	_ bin.Decoder     = &ReorderChatFiltersRequest{}
	_ bin.BareEncoder = &ReorderChatFiltersRequest{}
	_ bin.BareDecoder = &ReorderChatFiltersRequest{}
)

func (r *ReorderChatFiltersRequest) Zero() bool {
	if r == nil {
		return true
	}
	if !(r.ChatFilterIDs == nil) {
		return false
	}

	return true
}

// String implements fmt.Stringer.
func (r *ReorderChatFiltersRequest) String() string {
	if r == nil {
		return "ReorderChatFiltersRequest(nil)"
	}
	type Alias ReorderChatFiltersRequest
	return fmt.Sprintf("ReorderChatFiltersRequest%+v", Alias(*r))
}

// TypeID returns type id in TL schema.
//
// See https://core.telegram.org/mtproto/TL-tl#remarks.
func (*ReorderChatFiltersRequest) TypeID() uint32 {
	return ReorderChatFiltersRequestTypeID
}

// TypeName returns name of type in TL schema.
func (*ReorderChatFiltersRequest) TypeName() string {
	return "reorderChatFilters"
}

// TypeInfo returns info about TL type.
func (r *ReorderChatFiltersRequest) TypeInfo() tdp.Type {
	typ := tdp.Type{
		Name: "reorderChatFilters",
		ID:   ReorderChatFiltersRequestTypeID,
	}
	if r == nil {
		typ.Null = true
		return typ
	}
	typ.Fields = []tdp.Field{
		{
			Name:       "ChatFilterIDs",
			SchemaName: "chat_filter_ids",
		},
	}
	return typ
}

// Encode implements bin.Encoder.
func (r *ReorderChatFiltersRequest) Encode(b *bin.Buffer) error {
	if r == nil {
		return fmt.Errorf("can't encode reorderChatFilters#c3a5313d as nil")
	}
	b.PutID(ReorderChatFiltersRequestTypeID)
	return r.EncodeBare(b)
}

// EncodeBare implements bin.BareEncoder.
func (r *ReorderChatFiltersRequest) EncodeBare(b *bin.Buffer) error {
	if r == nil {
		return fmt.Errorf("can't encode reorderChatFilters#c3a5313d as nil")
	}
	b.PutInt(len(r.ChatFilterIDs))
	for _, v := range r.ChatFilterIDs {
		b.PutInt32(v)
	}
	return nil
}

// Decode implements bin.Decoder.
func (r *ReorderChatFiltersRequest) Decode(b *bin.Buffer) error {
	if r == nil {
		return fmt.Errorf("can't decode reorderChatFilters#c3a5313d to nil")
	}
	if err := b.ConsumeID(ReorderChatFiltersRequestTypeID); err != nil {
		return fmt.Errorf("unable to decode reorderChatFilters#c3a5313d: %w", err)
	}
	return r.DecodeBare(b)
}

// DecodeBare implements bin.BareDecoder.
func (r *ReorderChatFiltersRequest) DecodeBare(b *bin.Buffer) error {
	if r == nil {
		return fmt.Errorf("can't decode reorderChatFilters#c3a5313d to nil")
	}
	{
		headerLen, err := b.Int()
		if err != nil {
			return fmt.Errorf("unable to decode reorderChatFilters#c3a5313d: field chat_filter_ids: %w", err)
		}

		if headerLen > 0 {
			r.ChatFilterIDs = make([]int32, 0, headerLen%bin.PreallocateLimit)
		}
		for idx := 0; idx < headerLen; idx++ {
			value, err := b.Int32()
			if err != nil {
				return fmt.Errorf("unable to decode reorderChatFilters#c3a5313d: field chat_filter_ids: %w", err)
			}
			r.ChatFilterIDs = append(r.ChatFilterIDs, value)
		}
	}
	return nil
}

// EncodeTDLibJSON implements tdjson.TDLibEncoder.
func (r *ReorderChatFiltersRequest) EncodeTDLibJSON(b tdjson.Encoder) error {
	if r == nil {
		return fmt.Errorf("can't encode reorderChatFilters#c3a5313d as nil")
	}
	b.ObjStart()
	b.PutID("reorderChatFilters")
	b.Comma()
	b.FieldStart("chat_filter_ids")
	b.ArrStart()
	for _, v := range r.ChatFilterIDs {
		b.PutInt32(v)
		b.Comma()
	}
	b.StripComma()
	b.ArrEnd()
	b.Comma()
	b.StripComma()
	b.ObjEnd()
	return nil
}

// DecodeTDLibJSON implements tdjson.TDLibDecoder.
func (r *ReorderChatFiltersRequest) DecodeTDLibJSON(b tdjson.Decoder) error {
	if r == nil {
		return fmt.Errorf("can't decode reorderChatFilters#c3a5313d to nil")
	}

	return b.Obj(func(b tdjson.Decoder, key []byte) error {
		switch string(key) {
		case tdjson.TypeField:
			if err := b.ConsumeID("reorderChatFilters"); err != nil {
				return fmt.Errorf("unable to decode reorderChatFilters#c3a5313d: %w", err)
			}
		case "chat_filter_ids":
			if err := b.Arr(func(b tdjson.Decoder) error {
				value, err := b.Int32()
				if err != nil {
					return fmt.Errorf("unable to decode reorderChatFilters#c3a5313d: field chat_filter_ids: %w", err)
				}
				r.ChatFilterIDs = append(r.ChatFilterIDs, value)
				return nil
			}); err != nil {
				return fmt.Errorf("unable to decode reorderChatFilters#c3a5313d: field chat_filter_ids: %w", err)
			}
		default:
			return b.Skip()
		}
		return nil
	})
}

// GetChatFilterIDs returns value of ChatFilterIDs field.
func (r *ReorderChatFiltersRequest) GetChatFilterIDs() (value []int32) {
	if r == nil {
		return
	}
	return r.ChatFilterIDs
}

// ReorderChatFilters invokes method reorderChatFilters#c3a5313d returning error if any.
func (c *Client) ReorderChatFilters(ctx context.Context, chatfilterids []int32) error {
	var ok Ok

	request := &ReorderChatFiltersRequest{
		ChatFilterIDs: chatfilterids,
	}
	if err := c.rpc.Invoke(ctx, request, &ok); err != nil {
		return err
	}
	return nil
}
